<?php

function get_excerpt_by_id($post_id){
$the_post = get_post($post_id); //Gets post ID
$the_excerpt = $the_post->post_content; //Gets post_content to be used as a basis for the excerpt
$excerpt_length = 35; //Sets excerpt length by word count
$the_excerpt = strip_tags(strip_shortcodes($the_excerpt)); //Strips tags and images
$words = explode(' ', $the_excerpt, $excerpt_length + 1);
if(count($words) > $excerpt_length) :
array_pop($words);
array_push($words, '…');
$the_excerpt = implode(' ', $words);
endif;
$the_excerpt = '<p>' . $the_excerpt . '</p>';
return $the_excerpt;
}

// Taxonomy category shortcode
function mt_posts_carousel_cat_func($atts, $content) { 
    extract(shortcode_atts(array(
            'columns'    => '4',
            'number'    => '4',
            'image'    => 'yes',
            'category'      => ''
            ), $atts));

    global $post;
    if( $category != ('') ) {      
		$args = array(
		'post_type' => 'post',
        'showposts' => $number,
        'category_name' => $category
		); 
   } else {
		$args = array(
		'post_type' => 'post',
        'showposts' => $number
		);
   }
   
    query_posts($args);
    
    $output = '';
    $temp_title = '';
    $temp_link = '';
    $temp_excerpt = '';
    $temp_image = '';
    
    if( $columns == '1' ) {
		
        $output = '<div class="1-column">';
		
    ;} elseif ( $columns == '2' ) {
		
        $output = '<div class="2-column">'; 
		 
    ;} elseif ( $columns == '3' ) {   
	 
        $output = '<div class="3-column">';   
		  
    ;} else {    
	
        $output = '<div class="4-column">';  
		
    }

    if (have_posts($args)) : while (have_posts()) : the_post();
	
        $temp_title = get_the_title($post->ID);
        $temp_link = get_permalink($post->ID);
        $temp_excerpt = get_the_excerpt();
        $temp_image = get_the_post_thumbnail($post->ID, 'full'); 
		
     if( $image == 'yes' ) {
		 
        $output .= '<div><a href="'.$temp_link.'">'.$temp_image.'</a><h2><a href="'.$temp_link.'">'.$temp_title.'</a></h2><p>'.$temp_excerpt.'</p></div>';
		
     ;} 
	 
	 else {  
	   
        $output .= '<div><h2><a href="'.$temp_link.'">'.$temp_title.'</a></h2><p>'.$temp_excerpt.'</p></div>';
		  
    }

    endwhile; 
   
      $output .= '</div>';
      
   endif;
   
   
   wp_reset_query();
   return $output;
   
   
}

add_shortcode('posts-carousel', 'mt_posts_carousel_cat_func'); 

?>